///////////////////////////////////////////////////////////
//  IEntity.cs
//  Implementation of the Interface IEntity
//  Generated by Enterprise Architect
//  Created on:      09-Feb-2018 15:31:36
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.EntityPayload;
using Org.OMG.TACSIT.DataInterface;
namespace Org.OMG.TACSIT.DataInterface {
	/// <summary>
	/// This interface accesses to an entity.
	/// </summary>
	public interface IEntity {

        /// <summary>
        /// Interface invoked as a callback when a bulk of entity creation, modification or
        /// deletion happens.
        /// </summary>
        /// <param name="e"></param>
        public delegate void entityChanged(Org.OMG.TACSIT.DataPayload.CallbackData.EntityChangeEventList e);

        /// <summary>
        /// Interface invoked as a callback when entities are created, modified or deleted
        /// within a group.
        ///      The implementation of this callback may return the exception StopListening
        /// as soon it wants to kill the listeners.
        /// </summary>
        public event entityChanged EntityChange; 

		/// <summary>
		/// Get the payload of the entity.
		/// </summary>
		Org.OMG.TACSIT.DataPayload.EntityPayload.EntityPayload read();

		/// <summary>
		/// Get the interface to the history of the entity.
		/// </summary>
		Org.OMG.TACSIT.DataInterface.IEntityHistory getHistory();

		/// <summary>
		/// Get back the matching Group interface.
		/// </summary>
		Org.OMG.TACSIT.DataInterface.IGroup getGroup();

		/// <summary>
		/// Update the entity and return the new payload.
		///        The implementation may return a NotImplemented exception.
		/// </summary>
		/// <param name="payload"></param>
		Org.OMG.TACSIT.DataPayload.EntityPayload.EntityPayload update(Org.OMG.TACSIT.DataPayload.EntityPayload.EntityPayload payload);

		/// <summary>
		/// Delete the entity.
		///        The implementation may return a NotImplemented exception.
		/// </summary>
		void delete();

		/// <summary>
		/// Listen to the history creation, deletion, and update events for the entity at a
		/// given rate.
		///        This method may return the InadequateRate exception (if the
		/// implementation deems this parameter as unsuitable) or the TooManyListeners
		/// exception (if the implementation limit the number of listeners) or the
		/// NotImplemented exception if this capability is not available.
		/// </summary>
		/// <param name="l"></param>
		/// <param name="rate"></param>
		void addListener(Org.OMG.TACSIT.DataInterface.IHistoryChangeListener l, int rate);

		/// <summary>
		/// Listen to the history creation, deletion, and update events for the entity.
		///        This method may return the TooManyListeners exception (if the
		/// implementation limit the number of listeners).
		/// </summary>
		/// <param name="l"></param>
		void addListener(Org.OMG.TACSIT.DataInterface.IHistoryChangeListener l);

		/// <summary>
		/// Remove a previously set listener and return the UnknownListener exception if
		/// the listener does not exist (any more).
		/// </summary>
		/// <param name="l"></param>
		void removeListener(Org.OMG.TACSIT.DataInterface.IHistoryChangeListener l);
	}//end IEntity

}//end namespace DataInterface