///////////////////////////////////////////////////////////
//  IEntity.cs
//  Implementation of the Interface IEntity
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:16:38
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.DataPayload.EntityPayload;
using Org.OMG.TACSIT.DataInterface;
using Org.OMG.TACSIT.DataPayload.EntityPayloadManagement;
using Org.OMG.TACSIT.Controller;
namespace Org.OMG.TACSIT.DataInterface {
	/// <summary>
	/// This interface accesses to an entity.
	/// </summary>
    public interface IEntity : Org.OMG.TACSIT.Controller.IEntity
    {

		/// <summary>
		/// Get the payload of the entity.
		/// </summary>
		Org.OMG.TACSIT.DataPayload.EntityPayload.EntityPayload Read();

		/// <summary>
		/// Get the interface to the history of the entity.
		/// </summary>
		Org.OMG.TACSIT.DataInterface.IEntityHistory GetHistory();

		/// <summary>
		/// Get back the matching Group interface.
		/// </summary>
		Org.OMG.TACSIT.DataInterface.IGroup GetGroup();

		/// <summary>
		/// Update the entity and return the new payload.
		///        The implementation may return a NotImplemented exception.
		/// </summary>
		/// <param name="payload"></param>
		Org.OMG.TACSIT.DataPayload.EntityPayload.EntityPayload Update(Org.OMG.TACSIT.DataPayload.EntityPayload.EntityPayload payload);

		/// <summary>
		/// Update the entity with a subset of the data defined in an EntityPayload and
		/// return the new payload.
		///        The implementation may return a InconsistentChunk exception.
		///        The implementation may return a NotImplemented exception.
		/// </summary>
		/// <param name="chunk"></param>
		Org.OMG.TACSIT.DataPayload.EntityPayload.EntityPayload Update(Org.OMG.TACSIT.DataPayload.EntityPayloadManagement.EntityPayloadChunk chunk);

		/// <summary>
		/// Delete the entity.
		///        The implementation may return a NotImplemented exception.
		/// </summary>
		void Delete();

		/// <summary>
		/// Listen to the history creation, deletion, and update events for the entity at a
		/// given rate.
		///        This method may return the InadequateRate exception (if the
		/// implementation deems this parameter as unsuitable) or the TooManyListeners
		/// exception (if the implementation limit the number of listeners) or the
		/// NotImplemented exception if this capability is not available.
		/// </summary>
		/// <param name="rate"></param>
		Org.OMG.TACSIT.DataInterface.IHistoryChangePublisher GetChangePublisher(int rate);

		/// <summary>
		/// Listen to the history creation, deletion, and update events for the entity.
		///        This method may return the TooManyListeners exception (if the
		/// implementation limit the number of listeners).
		/// </summary>
		Org.OMG.TACSIT.DataInterface.IHistoryChangePublisher GetChangePublisher();
	}//end IEntity

	/// <summary>
	/// Interface invoked as a callback when histories are created, modified or deleted
	/// for an entity.
	/// </summary>
	public interface IHistoryChangePublisher {

		/// <summary>
		/// Interface invoked as a callback when a bulk of history creation, modification
		/// or deletion happens.
		///      The implementation of this callback may return the exception StopListening
		/// as soon it wants to kill the listeners.
		/// </summary>
		event EventHandler<DataPayload.CallbackData.HistoryChangeEventList> HistoryChanged;
	}//end IHistoryChangePublisher

}//end namespace DataInterface